﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.IO;

namespace chat_history
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        private void menuMain_itemFile_itemExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void menuMain_itemFile_itemAbout_Click(object sender, EventArgs e)
        {
           frmAbout sForm = new frmAbout();
           sForm.ShowDialog();
        }

        private string chr (string input) {
            Char tc = Convert.ToChar(Convert.ToInt32(input));
            return Convert.ToString(tc);
        }

        private void btnConvert_Click(object sender, EventArgs e)
        {
            string msg, msga, msgb;
            string[] msgs, newarr;

            msg = txtInput.Text.Substring(4, txtInput.Text.Length-4);
            msgs = new string[msg.Length+20];

            List<string> tempout = new List<string>();
            List<string> newout = new List<string>();

            msga = ""; msgb = "";
            
            int cnt = 0;
            foreach (char c in msg)
            {
                msgs[cnt] += (Int32)c % 256;
                cnt += 1;
            }
            //msga = Regex.Replace(msga,"32-32-32","0");
            
            //msgs = Regex.Split(msga,"-");
            int x;

            for (x = 0; x < msgs.Length; x++)
            {
                if (msgs[x] == "32" && msgs[x + 1] == "32" && msgs[x + 2] == "32")
                {
                    tempout.Add("0");
                    x += 2;
                }
                else
                {
                    tempout.Add(msgs[x]);
                }
            }

            msgs = tempout.ToArray();

            for (x = 0; x < msgs.Length; x++)
            {
                if (msgs[x]		== "38" &&
			        msgs[x+1]		== "35" &&
			        (Convert.ToInt32(msgs[x+2],10)	>= 48 && Convert.ToInt32(msgs[x+2],10) <= 57) &&
			        (Convert.ToInt32(msgs[x+3],10)	>= 48 && Convert.ToInt32(msgs[x+3],10) <= 57) &&
			        (Convert.ToInt32(msgs[x+4],10)	>= 48 && Convert.ToInt32(msgs[x+4],10) <= 57) &&
			        (Convert.ToInt32(msgs[x+5],10)	>= 48 && Convert.ToInt32(msgs[x+5],10) <= 57) &&
			        (Convert.ToInt32(msgs[x+6],10)	>= 48 && Convert.ToInt32(msgs[x+6],10) <= 57) &&
			        msgs[x+7]		== "59") {
			        if (Convert.ToInt32(msgs[x+8],10) < 128 && Convert.ToInt32(msgs[x+8],10) > 0 && msgs[x+8] != "32") {
				        int counter = 8;
				        while (Convert.ToInt32(msgs[x+counter],10) < 128 && Convert.ToInt32(msgs[x+counter],10) > 0 && msgs[x+counter] != "32") {
					        counter += 1;
				        }
				        if (counter > 9) {
					        newout.Add("58");
                            newout.Add("0");
				        } else {
					        newout.Add("0");
				        }
				        x += counter - 1;
			        }
			        else {
				        x += 7;
			        }
		        }

                else if ((Convert.ToInt32(msgs[x],10) < 128 && Convert.ToInt32(msgs[x],10) > 0 && msgs[x] != "32") &&
				        (Convert.ToInt32(msgs[x+1],10) < 128 && Convert.ToInt32(msgs[x+1],10) > 0 && msgs[x+1] != "32")) {
			        int counter = 0;
			        while (Convert.ToInt32(msgs[x+counter],10) < 128 && Convert.ToInt32(msgs[x+counter],10) > 0 && msgs[x+counter] != "32") {
				        counter += 1;
			        }
			        if (counter > 1) {
				        newout.Add("58"); newout.Add("0");
			        } else {
				        newout.Add("0");
			        }
			        x += counter-1;
		        }
        		
		        else if ((Convert.ToInt32(msgs[x],10) < 128 && Convert.ToInt32(msgs[x],10) > 0 && msgs[x] != "32") &&
				        (Convert.ToInt32(msgs[x+1],10) < 128 && Convert.ToInt32(msgs[x+1],10) > 0 && msgs[x+1] != "32") &&
				        (msgs[x+2] == "32" && msgs[x+3]== "32" && msgs[x+4]== "32")) {
			        newout.Add("58"); newout.Add("0");
			        x += 4;
		        }
        		
		        else if (msgs[x] == "32" || msgs[x] == "0") {
			        if (Convert.ToInt32(msgs[x+1],10) < 32 && Convert.ToInt32(msgs[x+1],10) > 0) {
				        if (Convert.ToInt32(msgs[x+2],10) < 32 && Convert.ToInt32(msgs[x+2],10) > 0) {
					        if (msgs[x+3] == "32" || msgs[x+3] == "0") {
						        x +=3;
						        // While I understand that a
						        // break is suppossed to go here
						        // I decided that I wanted to keep
						        // all text from a user on one line
						        newout.Add("0");
					        }
					        // there isn't a need for an else
				        }
				        else if (msgs[x+2] == "32" || msgs[x+2] == "0") {
					        x +=2;
					        newout.Add("br");
				        }
				        // No need for an else
			        }
			        else {
                        newout.Add(msgs[x]);
			        }
		        }
        		
		        else {
			        newout.Add(msgs[x]);
		        }
            }

            // You can convert it back to an array if you would like to
            newarr = newout.ToArray();

            for (x = 0; x < newarr.Length; x++)
            {
                msgb += newarr[x] + "-";
            }

            for (x = 0; x < newarr.Length; x++)
            {
                if (newarr[x] == "br")
                {
                    msga += "\r\n";
                }
                else if ((newarr[x] == "32" || newarr[x] == "0") &&
				        (Convert.ToInt32(newarr[x+1],10) < 32 && Convert.ToInt32(newarr[x+1],10) > 0) &&
				        (newarr[x+2] == "32" || newarr[x+2] == "0")) {
			        x +=2;
			        msga += "\r\n";
		        }
		        else if (newarr[x] == "32") {
			        if (newarr[x+1] == "0") {
				        x += 1;
				        msga += "\r\n";
			        }
		        }
                
                else if (Convert.ToInt32(newarr[x], 10) < 32 && Convert.ToInt32(newarr[x], 10) > 0)
                {
                    if (newarr[x + 1] == "0" || newarr[x + 1] == "32")
                    {
                        // Hmm?
                        // Extra needed junk cleaner
                        x += 1;
                    }
                    else
                    {
                        msga += chr(newarr[x]);
                    }
                }
                else if (newarr[x] == "0")
                {
                    msga += " ";
                }
                else
                {
                    if (newarr[x] != "")
                    {
                        msga += chr(newarr[x]);
                    }
                }
	        }

            /*for (int x = 0; x < arr.Length; x++)
            {
                msga += arr[x] + "-";
            }*/
            /*for (int x = 0; x < msgs.Length; x++)
            {
                msga += msgs[x] + "-";
            }*/
            txtOutput.Text = msga;
            //txtOutput.Text = msgb;
        }

        private void txtInput_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Control == true && e.KeyCode == Keys.A)
            {
                txtInput.SelectAll();
            }
        }
    }
}
